/*
iCustom
  (
   NULL,0,"_Channel@MACD_ATR", //     -
   FastMA,SlowMA,SlowMAshift,Method, //  
   ATR,xVolatility,Sens, //  
   ChannelMA,Border, //  
   ShowTrend,ShowChannel,ShowZigZag,ShowFibo, // 
   BeamNumber, //      
   n, //  
   i //  
  );

*/
#property indicator_chart_window //   
#property indicator_buffers 8
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
#property indicator_color5 Green // .  . 
#property indicator_color6 Red // .  . 
#property indicator_color7 Blue // 
#property indicator_color8 Gray // 
//  
   // Trend
extern int FastMA=12; //  
extern int SlowMA=26; //  
extern int SlowMAshift=0; //  
extern int Method=1; //  
extern int PriceField=0; //  
   // 
 int Volatility=1;
extern int VolatilityPeriod=5;
extern int BackPeriod=444;
extern double xVolatility=0.5;
extern double Sens=0; //   .
   //   
extern double ChannelMA=1; //  ; <0 -     
   // 
extern int Border=0; //   .  .
   // 
extern int ShowTrend=0; //  : 1 -  High/Low, 2 -  Close; <0 - =(.,.)
extern int ShowChannel=2; //  : 1 -   , 2 -   
extern int ShowZigZag=1; //  : 1 -   , 2 -   
extern int ShowFibo=2; // 1 - , 2 - 
extern int BeamNumber=1; //      

// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         ChTopS[], // .  . 
         ChBotS[], // .  . 
         Trend[], // Trend
         Mediana[]; // 
//  
double sens; // .  
double smch; // .  
bool dir; // 0- , 1 - 
double max,min; //  ., 
double top,bot,top1,bot1; // , 
double topS0,botS0,topS1,botS1; // ,    (. .)
//int jDn,jUp; //    
double brd; //   .   
bool trend; // 0 - , 1 - 
bool fCr,bCr;
datetime th0,th1,tl0,tl1;
bool chma; //   : 0 -  . . , 1 - EMA
bool str; // 1 -   , 0 -  . .  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndDescr();
   if(VolatilityPeriod>0) Volatility=1;
   else {Volatility=2; VolatilityPeriod=-VolatilityPeriod;}
   sens=Sens*Point;
   
   if(ChannelMA>0) chma=1; else {chma=0; ChannelMA=-ChannelMA;}
   if(ChannelMA>1) smch=2.0/(1+ChannelMA); else smch=ChannelMA;
   brd=Border*Point; 
   
   if(ShowTrend<0) {ShowTrend=-ShowTrend; str=0;} else str=1;
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexLabel(3,"ChBot");

   SetIndexBuffer(4,ChTopS);
   SetIndexEmptyValue(4,0.0);
   SetIndexLabel(4,"ChTopS");

   SetIndexBuffer(5,ChBotS);
   SetIndexEmptyValue(5,0.0);
   SetIndexLabel(5,"ChBotS");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE,2);
      SetIndexStyle(3,DRAW_LINE,2);
      SetIndexStyle(4,DRAW_LINE);
      SetIndexStyle(5,DRAW_LINE);
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
     }

   SetIndexBuffer(6,Trend);
   SetIndexLabel(6,"Trend");
   if(ShowTrend>0) SetIndexStyle(6,DRAW_LINE,0,2);
   else SetIndexStyle(6,DRAW_NONE);
   
//   SetIndexStyle(6,DRAW_LINE,0,2);
   SetIndexBuffer(7,Mediana);
   SetIndexLabel(7,"Mediana");
   SetIndexStyle(7,DRAW_LINE,1);
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 

   for(int i=limit; i>=0; i--)
     {
      
      if(i>0) { //   
         // 
         if(PriceField==2 || PriceField==3) {
            double mafH=iMA(NULL,0,FastMA,0,Method,2, i); //   High
            double mafL=iMA(NULL,0,FastMA,0,Method,3, i); //   Low
           }
         else {
            mafH=iMA(NULL,0,FastMA,0,Method,PriceField, i); 
            mafL=mafH;
           }
         
         if(SlowMA>0) {
            if(PriceField==2 || PriceField==3) {
               double masH=iMA(NULL,0,SlowMA,SlowMAshift,Method,2, i); //   High
               double masL=iMA(NULL,0,SlowMA,SlowMAshift,Method,3, i); //   Low
              }
            else {
               masH=iMA(NULL,0,SlowMA,SlowMAshift,Method,PriceField, i); 
               masL=masH;
              }
           }
         else {
            masH=min;
            masL=max;
           }
         
         // MACD
         double macdH=mafH-masH; // MACD High
         double macdL=mafL-masL; // MACD Low
         
         // 
         if(xVolatility>0) 
            double vlt=xVolatility*iCustom(NULL,0,"_Volatility_FBA_NR",Volatility,VolatilityPeriod,1,BackPeriod,0, 1,i);
         else vlt=0;
         double sns=MathMax(vlt,sens);

         //  
         bool up=macdH> sns;
         bool dn=macdL<-sns;
         bool crTop=0,crBot=0; //   /

         static datetime tMax,tMin; // . /
         static double OP;
         if(dir) { //  
            if(Low[i]<min) {min=Low[i]; tMin=Time[i];} //    
            if(up) { //    , 
               bot1=bot; bot=min; //  .  .
               tl1=tl0; tl0=tMin; //  .  .
               int sh=iBarShift(NULL,0,tMin,0); //   
               if(ShowZigZag!=2) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
               
               if(chma) botS1=botS0; else botS1=bot1;
               botS0=smch*bot+(1-smch)*botS1;
               
               if(ShowChannel==1) 
                  for(int k=sh; k>i; k--) {ChBot[k]=bot; ChBotS[k]=botS0;}
               crBot=1; dir=0; //   
               max=High[i]; tMax=Time[i];
               // OP's
               double BA=top-bot1;
               double cop=bot+0.618*BA;
               double op=bot+BA;
               double xop=bot+1.618*BA;
               if(top<cop) OP=cop; else {if(top<op) OP=op; else {if(top<xop) OP=xop; else OP=top;}}
              }
           }
         else { //  
            if(High[i]>max) {max=High[i]; tMax=Time[i];} //    
            if(dn) { //    , 
               top1=top; top=max; //  .   
               th1=th0; th0=tMax; //  .   
               sh=iBarShift(NULL,0,tMax,0); //   
               if(ShowZigZag!=2) ZZpeak[sh]=top; else ZZpeak[i]=top;
               
               if(chma) topS1=topS0; else topS1=top1;
               topS0=smch*top+(1-smch)*topS1;
               
               if(ShowChannel==1) 
                  for(k=sh; k>i; k--) {ChTop[k]=top; ChTopS[k]=topS0;}
               crTop=1; dir=1; //   
               min=Low[i]; tMin=Time[i];
               // OP's
               BA=bot-top1;
               cop=top+0.618*BA;
               op=top+BA;
               xop=top+1.618*BA;
               if(bot>cop) OP=cop; else {if(bot>op) OP=op; else {if(bot>xop) OP=xop; else OP=bot;}}
              }
           }
        }


      // 
      Mediana[i]=dir;//(topS0+botS0)/2;

      // 
      if(brd<0) double brd1=MathMax(MathAbs(brd),vlt); else brd1=brd; // 
      if(str) {
         double topBrd=topS0+brd1; // ..   
         double botBrd=botS0-brd1; // ..   
        }
      else {
         topBrd=MathMax(topS0,top)+brd1;
         botBrd=MathMin(botS0,bot)-brd1;
        }
      if(ShowTrend==1) { //  High/Low
         if(High[i]>topBrd) trend=1; // .
         if( Low[i]<botBrd) trend=0; //  
        }
      if(ShowTrend==2) { //  Close
         if(Close[i+1]>topBrd) trend=1; // .
         if(Close[i+1]<botBrd) trend=0; //  
        }
      if(trend) Trend[i]=botBrd; else Trend[i]=topBrd; 
              
      //    
      bool crBrd=crTop || crBot;
      int pkN1,trN1,pkN2,trN2; //   /
      bool dirN; // 0 -  , 1 -  
      int iPeak1,iPeak2,iTrough1,iTrough2; //  
      double Peak1,Peak2,Trough1,Trough2; //  
      datetime tPeak1,tPeak2,tTrough1,tTrough2; //  
      datetime x1,x2,x3; //   
      double y1,y2,y3; //   
            
      // 0- 
      if(i==0 && (ShowZigZag==1 || (ShowFibo>0 && BeamNumber==0))) { 
         static double lo,hi; int i0; bool newX=0;

         if(dir) {
            if(crTop || !bCr) {
               x1=th0; y1=top;
               i0=ArrayMinimum(Low,iBarShift(NULL,0,x1,0),0); //  0- 
               lo=Low[i0];
               x2=Time[i0]; y2=lo;
               if(!bCr) {
                  ObjectCreate("beam0",OBJ_TREND,0, x1,y1,x2,y2); bCr=1;
                  ObjectSet("beam0",OBJPROP_COLOR,Magenta);
                  ObjectSet("beam0",OBJPROP_STYLE,2);
                  ObjectSet("beam0",OBJPROP_RAY,0);
               }
               else {
                  ObjectSet("beam0",OBJPROP_TIME1,x1);
                  ObjectSet("beam0",OBJPROP_PRICE1,y1);
                  ObjectSet("beam0",OBJPROP_TIME2,x2);
                  ObjectSet("beam0",OBJPROP_PRICE2,y2);
               }
            }
            else {
               if(Low[0]<lo) {
                  lo=Low[0]; x2=Time[0]; y2=lo; newX=1;
                  ObjectSet("beam0",OBJPROP_TIME2,x2);
                  ObjectSet("beam0",OBJPROP_PRICE2,y2);
               }
            }
         }
         else { //  
            if(crBot || !bCr) {
               x1=tl0; y1=bot;
               i0=ArrayMaximum(High,iBarShift(NULL,0,x1,0),0);
               hi=High[i0];
               x2=Time[i0]; y2=hi;
               if(!bCr) {
                  ObjectCreate("beam0",OBJ_TREND,0, x1,y1,x2,y2); bCr=1;
                  ObjectSet("beam0",OBJPROP_COLOR,Magenta);
                  ObjectSet("beam0",OBJPROP_STYLE,2);
                  ObjectSet("beam0",OBJPROP_RAY,0);
               }
               else {
                  ObjectSet("beam0",OBJPROP_TIME1,x1);
                  ObjectSet("beam0",OBJPROP_PRICE1,y1);
                  ObjectSet("beam0",OBJPROP_TIME2,x2);
                  ObjectSet("beam0",OBJPROP_PRICE2,y2);
               }
            }
            else {
               if(High[0]>hi) {
                  hi=High[0]; x2=Time[0]; y2=hi; newX=1;
                  ObjectSet("beam0",OBJPROP_TIME2,x2);
                  ObjectSet("beam0",OBJPROP_PRICE2,y2);
               }
            }
         }
      }      

      // 
      if(ShowFibo>0 && i==0 && (crBrd || !fCr || newX)) { // c 
         if(BeamNumber/2.0!=BeamNumber/2) { //    
            pkN1=BeamNumber/2+1; trN1=BeamNumber/2+1;
           }
         else { //  
            if(BeamNumber>0) bool dirX=dir; else dirX=!dir;
            if(dir) {pkN1=BeamNumber/2+1; trN1=BeamNumber/2;}
            else {pkN1=BeamNumber/2; trN1=BeamNumber/2+1;}
           }            
      
         iPeak1=peakN(pkN1,0); Peak1=High[iPeak1]; tPeak1=Time[iPeak1];
         iTrough1=troughN(trN1,0); Trough1=Low[iTrough1]; tTrough1=Time[iTrough1];
         dirN=tPeak1>tTrough1; // 0 -  , 1 -  
      
         if(ShowFibo==1) { // 
            if(dirN) {x1=tTrough1; y1=Trough1; x2=tPeak1; y2=Peak1;} //  
            else {x1=tPeak1; y1=Peak1; x2=tTrough1; y2=Trough1;} //  
            if(!fCr) {
               ObjectCreate("fibo",OBJ_FIBO,0,x1,y1,x2,y2); //fCr=1;
               setFibo(0);
              }
            else {
               ObjectSet("fibo",OBJPROP_TIME1,x1);
               ObjectSet("fibo",OBJPROP_TIME2,x2);
               ObjectSet("fibo",OBJPROP_PRICE1,y1);
               ObjectSet("fibo",OBJPROP_PRICE2,y2);
              }
           }

         if(ShowFibo>1) { //   
            if(dirN) {iPeak2=peakN(1,iPeak1+1); Peak2=High[iPeak2]; tPeak2=Time[iPeak2];}
            else {iTrough2=troughN(1,iTrough1+1); Trough2=Low[iTrough2]; tTrough2=Time[iTrough2];}
            
            if(ShowFibo==2) { // 
               if(dirN) //  
                  {x1=tPeak2; x2=tTrough1; x3=tPeak1; y1=Peak2; y2=Trough1; y3=Peak1;} 
               else //  
                  {x1=tTrough2; x2=tPeak1; x3=tTrough1; y1=Trough2; y2=Peak1; y3=Trough1;} 
              }
            else { // 
               if(dirN) //  
                  {x1=tPeak2; x3=tTrough1; x2=tPeak1; y1=Peak2; y3=Trough1; y2=Peak1;} 
               else //  
                  {x1=tTrough2; x3=tPeak1; x2=tTrough1; y1=Trough2; y3=Peak1; y2=Trough1;} 
              }

            if(!fCr) {
               switch(ShowFibo) {
                  case 2: //  
                     ObjectCreate("fibo",OBJ_EXPANSION,0,x1,y1,x2,y2,x3,y3); setFibo(0); break;
                  case 3: //  
                     ObjectCreate("fibo",OBJ_FIBOCHANNEL,0,x1,y1,x2,y2,x3,y3); setFibo(1); break;
                  case 4: //  
                     ObjectCreate("fibo",OBJ_CHANNEL,0,x1,y1,x2,y2,x3,y3); fCr=1;
                 }
              }
            else {
               ObjectSet("fibo",OBJPROP_TIME1,x1);
               ObjectSet("fibo",OBJPROP_TIME2,x2);
               ObjectSet("fibo",OBJPROP_TIME3,x3);
               ObjectSet("fibo",OBJPROP_PRICE1,y1);
               ObjectSet("fibo",OBJPROP_PRICE2,y2);
               ObjectSet("fibo",OBJPROP_PRICE3,y3);
              }
           }
        }

      //
      for(k=0; k<2; k++) {ChTop[i-k]=top; ChBot[i-k]=bot; ChTopS[i-k]=topS0; ChBotS[i-k]=botS0;}
     }

   return(0);
  }

//  
void setFibo(bool mode) {
   if(BeamNumber>0) color flClr=Blue; //  
   else flClr=Magenta;
   int stl=2; //  
   fCr=1;

   ObjectSet("fibo",OBJPROP_COLOR,flClr);
   ObjectSet("fibo",OBJPROP_LEVELCOLOR,flClr);
   ObjectSet("fibo",OBJPROP_LEVELSTYLE,stl);
   if(mode) { //   
      ObjectSet("fibo",OBJPROP_FIBOLEVELS,10);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+0,-2.618);
      ObjectSetFiboDescription("fibo",0,"-261.8%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+1,-2.0);
      ObjectSetFiboDescription("fibo",1,"-200.0%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+2,-1.618);
      ObjectSetFiboDescription("fibo",2,"-161.8%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+3,-1.382);
      ObjectSetFiboDescription("fibo",3,"-138.2%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+4,-0.382);
      ObjectSetFiboDescription("fibo",4,"-38.2%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+5,-0.618);
      ObjectSetFiboDescription("fibo",5,"-61.8%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+6,0.382);
      ObjectSetFiboDescription("fibo",6,"38.2%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+7,0.618);
      ObjectSetFiboDescription("fibo",7,"61.8%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+8,1.0);
      ObjectSetFiboDescription("fibo",8,"100.0%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+9,1.618);
      ObjectSetFiboDescription("fibo",9,"161.8%");
     }
   else { //  ./
      if(ShowFibo==2) {string _cop="COP",_op="OP",_xop="XOP";}
      else {_cop="61.8%";_op="100.0%";_xop="161.8%";}
      ObjectSet("fibo",OBJPROP_FIBOLEVELS,9);

      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+0,0.0);
      ObjectSetFiboDescription("fibo",0,"0.0%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+1,0.382);
      ObjectSetFiboDescription("fibo",1,"38.2%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+2,0.618);
      ObjectSetFiboDescription("fibo",2,_cop);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+3,1.0);
      ObjectSetFiboDescription("fibo",3,_op);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+4,1.382);
      ObjectSetFiboDescription("fibo",4,"138.2%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+5,1.618);
      ObjectSetFiboDescription("fibo",5,_xop);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+6,2.0);
      ObjectSetFiboDescription("fibo",6,"200.0%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+7,2.618);
      ObjectSetFiboDescription("fibo",7,"261.8%");
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+8,3.0);
      ObjectSetFiboDescription("fibo",8,"300.0%");
     }
  }
  
// -  
int reinit()
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(ChTopS,0.0);
   ArrayInitialize(ChBotS,0.0);
   ArrayInitialize(Trend,0.0);

   dir=0;max=0;min=0;top=0;bot=0;top1=0;bot1=0;//jDn=0;jUp=0;
   topS0=0;botS0=0;topS1=0;botS1=0;
   trend=0;
   th0=0;th1=0;tl0=0;tl1=0;
   if(fCr) {ObjectDelete("fibo"); fCr=0;}
   if(bCr) {ObjectDelete("beam0"); bCr=0;}

   return(0);
  }

void deinit() {
   Comment("");
   if(fCr) ObjectDelete("fibo");
   if(bCr) ObjectDelete("beam0");
  }
  
void IndDescr() {
   string _d,_ma;
   // MA
   switch(Method) {
      case 0: _ma="SMA"; break;
      case 1: _ma="EMA"; break;
      case 2: _ma="SMMA"; break;
      case 3: _ma="LWMA"; 
     }
   if(SlowMA>0) _d="Fast"+_ma+"("+FastMA+") "+"Slow"+_ma+"("+SlowMA+")";
   else _d="ZZprice"+_ma+"("+FastMA+")";
   if(SlowMAshift>0) _d=_d+"+"+SlowMAshift;
   string _pr;
   switch(PriceField) {
      case 0: _pr=" Close"; break;
      case 1: _pr=" Open"; break;
      case 2: _pr=" High/Low"; break;
      case 3: _pr=" High/Low"; break;
      case 4: _pr=" Median"; break;
      case 5: _pr=" Weighted"; 
     }
   _d=_d+_pr+"\n";
   // 
   if(ChannelMA!=1) _d=_d+"ChannelMA("+DoubleToStr(ChannelMA,2)+")"+"\n";
   // Sensitivity
   if(Volatility==1) string _vlt="ATR"; else _vlt="StDev";
   if(VolatilityPeriod>0 && xVolatility>0) {
      if(BackPeriod!=1) string _bp=" Back("+DoubleToStr(BackPeriod,2)+")";
      _d=_d+_vlt+"("+VolatilityPeriod+")"+_bp+" x"+DoubleToStr(xVolatility,2)+"\n";
     }
   if(Sens>0) _d=_d+"Sensitivity="+DoubleToStr(Sens,2)+" points"+"\n";
   if(ShowTrend>0 && Border!=0) _d=_d+"Border="+DoubleToStr(MathAbs(Border),0)+" points ";
   if(ShowTrend==1) _d=_d+"High/Low"+"\n";
   if(ShowTrend==2) _d=_d+"Close/Close"+"\n";
   
   Comment(_d);
  }

//     
int peakN(
   int n, //    (   1)
   int j) //    
  {
   if(n==0) //     "beam0"
      return(iBarShift(NULL,0,ObjectGet("beam0",OBJPROP_TIME2),0));
   int k=0; //   
   for(int i=j; i<Bars; i++) {
      if(ZZpeak[i]!=0) k++; //  
      if(k==n) return(i); //     
     }
   return(-1); //         
  }
  
//     
int troughN(
   int n, //    (   1)
   int j) //    
  {
   if(n==0) //     "beam0"
      return(iBarShift(NULL,0,ObjectGet("beam0",OBJPROP_TIME2),0));
   int k=0; //   
   for(int i=j; i<Bars; i++) {
      if(ZZtrough[i]!=0) k++; //  
      if(k==n) return(i); //     
     }
   return(-1); //         
  }
  
  